
package com.mundivia.aopmonitor;

import org.apache.log4j.Logger;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Pointcut;

import com.jamonapi.Monitor;
import com.jamonapi.MonitorFactory;


@Aspect
public class QuiterMonitorAspect {
    
    private static Monitor monitor;
    
    private static Logger logger = Logger
    .getLogger(QuiterMonitorAspect.class);
     
    @Pointcut(" execution(* com.quiter..*(..))")
    public void metodosQuiter(){
        
    }
    
    @Pointcut(" execution(* pruebasmundivia.pool.implementaciones.AfinityCacheTiempoConexionConexionesDMSPoolSinTimer.*Conexion(..))")
    public void metodosPool(){
        
    }
    
    @Pointcut(" execution(* asjava.uniobjects.*(..))")
    public void metodosUniverse(){
        
    }
    
    @Pointcut(" execution(* pruebasmundivia.pool.implementaciones.CommonsBasedConexionesDMSPool.*Conexion(..))")
    public void metodosCommonsPool(){
        
    }
    
    @Pointcut(" execution(* pruebasmundivia.pool.implementaciones.HashTableBasedAfinityCacheSinTimer.comprobarContenido(..))")
    public void metodosCache(){
        
    }
    
  
    /*@Around("metodosQuiter()||metodosMundivia()")*/
    @Around("metodosPool()")
    public Object aspecto(ProceedingJoinPoint jp){
       // monitor=MonitorFactory.start(jp.getSignature().toLongString());
        Object devolver=null;
        long t1=0,t2=0;
        try {
            t1=System.nanoTime();
            devolver=jp.proceed();
            t2=System.nanoTime();
        } catch (Throwable e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }finally{
            System.out.println(t2-t1);
           // monitor.stop();
            //logger.debug(monitor.toString());
           // System.out.println(monitor);
        }
        return devolver;
        
        
    }
    
//    @Pointcut("execution (* *(..))")
//    public void capaWeb(){
//        
//    }
//    
//    @Pointcut("execution(* *(..))")
//    public void capaDao(){
//        
//    }
//    
//    @Pointcut("execution(* *(..))")
//    public void capaModelo(){
//        
//    }
    
    

}
